class TasksController < ApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy, :download, :upload]

  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
    @solutions = Submission.get_submission_page(@task.id, params[:page])
    @comments = Comment.where(task: @task)
    #Submission.where(task_id: @task.id)
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)

    respond_to do |format|
      if @task.save
        MyJob.set(wait: 6.months).perform_later(@task)
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: 'Task was successfully destroyed.' }
      format.json { head :no_content }
    end
  end
  
  def upload
    if !session[:user].nil?
      if !params[:upload].nil?
        Submission.save_file(session[:user], params[:id], params[:upload])
        flash[:notice] = "File uploaded successfully"
      else
        flash[:notice] = "Empty file field"
      end
    else
      flash[:notice] = "Please, log in to submit solution"
    end
    redirect_to :back
  end
  
  def download
    @u = params[:uid]
    @t = params[:id]
    s = Submission.where(task_id:@t, user_id:@u).first
    file = Rails.root.join("public","data",@t,s.filename)
    send_file(file, :type=>s.mime, :disposition => :attachment)
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def task_params
      params.require(:task).permit(:number, :deadline, :url)
    end
end
