class Submission < ActiveRecord::Base
  belongs_to :user
  belongs_to :task
  
  def self.save_file(userid, taskid, upload)
    dir = Rails.root.join("public","data", taskid.to_s)
    if !File.exists? dir
      Dir.mkdir dir
    end
    fname = File.basename(upload[:file].original_filename)
    fname.gsub!(/^\w\.\_/, '_')
    path = File.join(dir,fname)
    File.open(path, "w") { |f| f.write (upload[:file].read) }
    s = Submission.new
    s.filename = fname
    s.mime = upload[:file].content_type
    s.user_id = userid
    s.task_id = taskid
    t = Task.find taskid
    s.late = t.deadline < Time.now
    s.save
  end
  
  def self.get_submission_page(id,page)
    Submission.where(task_id:id).paginate(:page=>page, :per_page=>1)
  end
end
