class User < ActiveRecord::Base
  has_many :submissions
  has_many :tasks, :through => :submissions

  attr_accessor :password
  before_save :encrypt_password
  
  validates :username,
    {
      :presence => true,
      :uniqueness => true,
      :length => {:in => 4..18},
    }
  validates :password, :confirmation => true, :if => :password_required?

  def encrypt_password
    return if password.blank?
    if new_record?
      self.salt = SecureRandom.hex(16)
    end
    self.encrypted_password = User.encrypt(password, salt)
  end
  
  def User.encrypt(password,salt)
    Digest::SHA1.hexdigest(password+salt)
  end
  
  def User.authenticate(username, password)
    user = User.find_by username: username
    user && user.authenticated?(password) ? user : nil
  end
  
  def authenticated?(pass)
    self.encrypted_password == User.encrypt(pass,self.salt)
  end
  
  def password_required?
    encrypted_password.blank? || !password.blank?
  end
end
